<!DOCTYPE html><html><head>
    <meta charset="utf-8"/>
    <meta name="author" content="Apple Inc."/>
    <meta name="viewport" content="width=device-width initial-scale=1"/>
    
    <a class="dashingAutolink" name="autolink-197"></a><a class="dashAnchor" name="//apple_ref/cpp/Guide/Type%20Casting%20%E2%80%94%20The%20Swift%20Programming%20Language%20%28Swift%204.2%29"></a><title>Type Casting &mdash; The Swift Programming Language (Swift 4.2)</title>
    
    <link rel="license" href="https://docs.swift.org/LICENSE.txt"/>
    <link rel="stylesheet" media="all" href="../_static/stylesheets/application.css"/>
    <link rel="stylesheet" media="all" href="../_static/stylesheets/tspl.css"/>
    <link rel="shortcut icon" sizes="16x16 24x24 32x32 48x48 64x64" type="image/vnd.microsoft.icon" href="../../favicon.ico"/>
    <link rel="apple-touch-icon" href="https://docs.swift.org/apple-touch-icon.png"/>
    <link rel="apple-touch-icon" sizes="57x57" href="https://docs.swift.org/apple-touch-icon-57x57.png"/>
    <link rel="apple-touch-icon" sizes="72x72" href="https://docs.swift.org/apple-touch-icon-72x72.png"/>
    <link rel="apple-touch-icon" sizes="76x76" href="https://docs.swift.org/apple-touch-icon-76x76.png"/>
    <link rel="apple-touch-icon" sizes="114x114" href="https://docs.swift.org/apple-touch-icon-114x114.png"/>
    <link rel="apple-touch-icon" sizes="120x120" href="https://docs.swift.org/apple-touch-icon-120x120.png"/>
    <link rel="apple-touch-icon" sizes="144x144" href="https://docs.swift.org/apple-touch-icon-144x144.png"/>
    <link rel="apple-touch-icon" sizes="152x152" href="https://docs.swift.org/apple-touch-icon-152x152.png"/>
    <link rel="apple-touch-icon" sizes="180x180" href="https://docs.swift.org/apple-touch-icon-180x180.png"/>
    <link rel="mask-icon" href="https://docs.swift.org/assets/images/icon-swift.svg" color="#F05339"/> 
  </head>
  <body>


<nav role="navigation">
    <header role="banner">
      <h1 id="logo">
        <a href="https://swift.org/" title="Swift.org" role="img" aria-label="Swift.org">
          Swift.org
        </a>
      </h1>
    </header>

    <div id="menu-toggle" class="menu-toggle open"></div>

    <h2>The Swift Programming Language<div>Swift 4.2</div></h2>

    <ul>
    <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../index.html">Welcome to Swift</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="TheBasics.html">Language Guide</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="TheBasics.html">The Basics</a></li>
<li class="toctree-l2"><a class="reference internal" href="BasicOperators.html">Basic Operators</a></li>
<li class="toctree-l2"><a class="reference internal" href="StringsAndCharacters.html">Strings and Characters</a></li>
<li class="toctree-l2"><a class="reference internal" href="CollectionTypes.html">Collection Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="ControlFlow.html">Control Flow</a></li>
<li class="toctree-l2"><a class="reference internal" href="Functions.html">Functions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Closures.html">Closures</a></li>
<li class="toctree-l2"><a class="reference internal" href="Enumerations.html">Enumerations</a></li>
<li class="toctree-l2"><a class="reference internal" href="ClassesAndStructures.html">Structures and Classes</a></li>
<li class="toctree-l2"><a class="reference internal" href="Properties.html">Properties</a></li>
<li class="toctree-l2"><a class="reference internal" href="Methods.html">Methods</a></li>
<li class="toctree-l2"><a class="reference internal" href="Subscripts.html">Subscripts</a></li>
<li class="toctree-l2"><a class="reference internal" href="Inheritance.html">Inheritance</a></li>
<li class="toctree-l2"><a class="reference internal" href="Initialization.html">Initialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="Deinitialization.html">Deinitialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="OptionalChaining.html">Optional Chaining</a></li>
<li class="toctree-l2"><a class="reference internal" href="ErrorHandling.html">Error Handling</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="TypeCasting.html#">Type Casting</a></li>
<li class="toctree-l2"><a class="reference internal" href="NestedTypes.html">Nested Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="Extensions.html">Extensions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Protocols.html">Protocols</a></li>
<li class="toctree-l2"><a class="reference internal" href="Generics.html">Generics</a></li>
<li class="toctree-l2"><a class="reference internal" href="AutomaticReferenceCounting.html">Automatic Reference Counting</a></li>
<li class="toctree-l2"><a class="reference internal" href="MemorySafety.html">Memory Safety</a></li>
<li class="toctree-l2"><a class="reference internal" href="AccessControl.html">Access Control</a></li>
<li class="toctree-l2"><a class="reference internal" href="AdvancedOperators.html">Advanced Operators</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../ReferenceManual/AboutTheLanguageReference.html">Language Reference</a></li>
<li class="toctree-l1"><a class="reference internal" href="../RevisionHistory/RevisionHistory.html">Revision History</a></li>
</ul>

    <li class="toctree-l1 return"><a class="reference internal" href="https://swift.org/">&larr; Return to Swift.org</a></li>
    </ul>
</nav>




<main role="main">
    <article class="page">
        <menu id="bashful" type="toolbar">
          <div class="inner">
            <menuitem id="jump_to" class="menu-bar-item closed">
            <span id="jump_to_toggle">On This Page</span>
            <div class="chevron">
                <div class="chevy chevron-left"></div>
                <div class="chevy chevron-right"></div>
            </div>
            <menu type="list" class="details">
                <ul>
<li><a class="reference internal" href="TypeCasting.html#">Type Casting</a><ul>
<li><a class="reference internal" href="TypeCasting.html#ID339">Defining a Class Hierarchy for Type Casting</a></li>
<li><a class="reference internal" href="TypeCasting.html#ID340">Checking Type</a></li>
<li><a class="reference internal" href="TypeCasting.html#ID341">Downcasting</a></li>
<li><a class="reference internal" href="TypeCasting.html#ID342">Type Casting for Any and AnyObject</a></li>
</ul>
</li>
</ul>

            </menu>
            </menuitem>
          </div>
        </menu>

        
  <div class="section" id="type-casting">
<h1>Type Casting<a class="headerlink" href="TypeCasting.html#type-casting" title="Permalink to this headline"></a></h1>
<p><em>Type casting</em> is a way to check the type of an instance, or to treat that instance as a different superclass or subclass from somewhere else in its own class hierarchy.</p>
<p>Type casting in Swift is implemented with the <code class="docutils literal"><span class="pre">is</span></code> and <code class="docutils literal"><span class="pre">as</span></code> operators. These two operators provide a simple and expressive way to check the type of a value or cast a value to a different type.</p>
<p>You can also use type casting to check whether a type conforms to a protocol, as described in <a class="reference internal" href="Protocols.html#ID283"><span class="std std-ref">Checking for Protocol Conformance</span></a>.</p>
<div class="section" id="ID339">
<a class="dashingAutolink" name="autolink-198"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Defining%20a%20Class%20Hierarchy%20for%20Type%20Casting"></a><h2>Defining a Class Hierarchy for Type Casting<a class="headerlink" href="TypeCasting.html#ID339" title="Permalink to this headline"></a></h2>
<p>You can use type casting with a hierarchy of classes and subclasses to check the type of a particular class instance and to cast that instance to another class within the same hierarchy. The three code snippets below define a hierarchy of classes and an array containing instances of those classes, for use in an example of type casting.</p>
<p>The first snippet defines a new base class called <code class="docutils literal"><span class="pre">MediaItem</span></code>. This class provides basic functionality for any kind of item that appears in a digital media library. Specifically, it declares a <code class="docutils literal"><span class="pre">name</span></code> property of type <code class="docutils literal"><span class="pre">String</span></code>, and an <code class="docutils literal"><span class="pre">init</span> <span class="pre">name</span></code> initializer. (It is assumed that all media items, including all movies and songs, will have a name.)</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">MediaItem</span> {
</li><li>    <span class="k">var</span> <span class="nv">name</span>: <span class="nc">String</span>
</li><li>    <span class="k">init</span>(<span class="nv">name</span>: <span class="nc">String</span>) {
</li><li>        <span class="k">self</span>.<span class="nv">name</span> = <span class="nv">name</span>
</li><li>    }
</li><li>}
</li></ol></pre></div></div>
<p>The next snippet defines two subclasses of <code class="docutils literal"><span class="pre">MediaItem</span></code>. The first subclass, <code class="docutils literal"><span class="pre">Movie</span></code>, encapsulates additional information about a movie or film. It adds a <code class="docutils literal"><span class="pre">director</span></code> property on top of the base <code class="docutils literal"><span class="pre">MediaItem</span></code> class, with a corresponding initializer. The second subclass, <code class="docutils literal"><span class="pre">Song</span></code>, adds an <code class="docutils literal"><span class="pre">artist</span></code> property and initializer on top of the base class:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">Movie</span>: <span class="nc">MediaItem</span> {
</li><li>    <span class="k">var</span> <span class="nv">director</span>: <span class="nc">String</span>
</li><li>    <span class="k">init</span>(<span class="nv">name</span>: <span class="nc">String</span>, <span class="nv">director</span>: <span class="nc">String</span>) {
</li><li>        <span class="k">self</span>.<span class="nv">director</span> = <span class="nv">director</span>
</li><li>        <span class="k">super</span>.<span class="nv">init</span>(<span class="nv">name</span>: <span class="nv">name</span>)
</li><li>    }
</li><li>}
</li><li>
</li><li><span class="k">class</span> <span class="nv">Song</span>: <span class="nc">MediaItem</span> {
</li><li>    <span class="k">var</span> <span class="nv">artist</span>: <span class="nc">String</span>
</li><li>    <span class="k">init</span>(<span class="nv">name</span>: <span class="nc">String</span>, <span class="nv">artist</span>: <span class="nc">String</span>) {
</li><li>        <span class="k">self</span>.<span class="nv">artist</span> = <span class="nv">artist</span>
</li><li>        <span class="k">super</span>.<span class="nv">init</span>(<span class="nv">name</span>: <span class="nv">name</span>)
</li><li>    }
</li><li>}
</li></ol></pre></div></div>
<p>The final snippet creates a constant array called <code class="docutils literal"><span class="pre">library</span></code>, which contains two <code class="docutils literal"><span class="pre">Movie</span></code> instances and three <code class="docutils literal"><span class="pre">Song</span></code> instances. The type of the <code class="docutils literal"><span class="pre">library</span></code> array is inferred by initializing it with the contents of an array literal. Swift&rsquo;s type checker is able to deduce that <code class="docutils literal"><span class="pre">Movie</span></code> and <code class="docutils literal"><span class="pre">Song</span></code> have a common superclass of <code class="docutils literal"><span class="pre">MediaItem</span></code>, and so it infers a type of <code class="docutils literal"><span class="pre">[MediaItem]</span></code> for the <code class="docutils literal"><span class="pre">library</span></code> array:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">library</span> = [
</li><li>    <span class="nv">Movie</span>(<span class="nv">name</span>: <span class="s">&#34;Casablanca&#34;</span>, <span class="nv">director</span>: <span class="s">&#34;Michael Curtiz&#34;</span>),
</li><li>    <span class="nv">Song</span>(<span class="nv">name</span>: <span class="s">&#34;Blue Suede Shoes&#34;</span>, <span class="nv">artist</span>: <span class="s">&#34;Elvis Presley&#34;</span>),
</li><li>    <span class="nv">Movie</span>(<span class="nv">name</span>: <span class="s">&#34;Citizen Kane&#34;</span>, <span class="nv">director</span>: <span class="s">&#34;Orson Welles&#34;</span>),
</li><li>    <span class="nv">Song</span>(<span class="nv">name</span>: <span class="s">&#34;The One And Only&#34;</span>, <span class="nv">artist</span>: <span class="s">&#34;Chesney Hawkes&#34;</span>),
</li><li>    <span class="nv">Song</span>(<span class="nv">name</span>: <span class="s">&#34;Never Gonna Give You Up&#34;</span>, <span class="nv">artist</span>: <span class="s">&#34;Rick Astley&#34;</span>)
</li><li>]
</li><li><span class="c">// the type of &#34;library&#34; is inferred to be [MediaItem]</span>
</li></ol></pre></div></div>
<p>The items stored in <code class="docutils literal"><span class="pre">library</span></code> are still <code class="docutils literal"><span class="pre">Movie</span></code> and <code class="docutils literal"><span class="pre">Song</span></code> instances behind the scenes. However, if you iterate over the contents of this array, the items you receive back are typed as <code class="docutils literal"><span class="pre">MediaItem</span></code>, and not as <code class="docutils literal"><span class="pre">Movie</span></code> or <code class="docutils literal"><span class="pre">Song</span></code>. In order to work with them as their native type, you need to <em>check</em> their type, or <em>downcast</em> them to a different type, as described below.</p>
</div>
<div class="section" id="ID340">
<a class="dashingAutolink" name="autolink-199"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Checking%20Type"></a><h2>Checking Type<a class="headerlink" href="TypeCasting.html#ID340" title="Permalink to this headline"></a></h2>
<p>Use the <em>type check operator</em> (<code class="docutils literal"><span class="pre">is</span></code>) to check whether an instance is of a certain subclass type. The type check operator returns <code class="docutils literal"><span class="pre">true</span></code> if the instance is of that subclass type and <code class="docutils literal"><span class="pre">false</span></code> if it is not.</p>
<p>The example below defines two variables, <code class="docutils literal"><span class="pre">movieCount</span></code> and <code class="docutils literal"><span class="pre">songCount</span></code>, which count the number of <code class="docutils literal"><span class="pre">Movie</span></code> and <code class="docutils literal"><span class="pre">Song</span></code> instances in the <code class="docutils literal"><span class="pre">library</span></code> array:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">var</span> <span class="nv">movieCount</span> = <span class="m">0</span>
</li><li><span class="k">var</span> <span class="nv">songCount</span> = <span class="m">0</span>
</li><li>
</li><li><span class="k">for</span> <span class="nv">item</span> <span class="k">in</span> <span class="nv">library</span> {
</li><li>    <span class="k">if</span> <span class="nv">item</span> <span class="k">is</span> <span class="nc">Movie</span> {
</li><li>        <span class="nv">movieCount</span> += <span class="m">1</span>
</li><li>    } <span class="k">else</span> <span class="k">if</span> <span class="nv">item</span> <span class="k">is</span> <span class="nc">Song</span> {
</li><li>        <span class="nv">songCount</span> += <span class="m">1</span>
</li><li>    }
</li><li>}
</li><li>
</li><li><span class="nv">print</span>(<span class="s">&#34;Media library contains </span>\<span class="p">(</span><span class="nv">movieCount</span><span class="p">)</span><span class="s"> movies and </span>\<span class="p">(</span><span class="nv">songCount</span><span class="p">)</span><span class="s"> songs&#34;</span>)
</li><li><span class="c">// Prints &#34;Media library contains 2 movies and 3 songs&#34;</span>
</li></ol></pre></div></div>
<p>This example iterates through all items in the <code class="docutils literal"><span class="pre">library</span></code> array. On each pass, the <code class="docutils literal"><span class="pre">for</span></code>-<code class="docutils literal"><span class="pre">in</span></code> loop sets the <code class="docutils literal"><span class="pre">item</span></code> constant to the next <code class="docutils literal"><span class="pre">MediaItem</span></code> in the array.</p>
<p><code class="docutils literal"><span class="pre">item</span> <span class="pre">is</span> <span class="pre">Movie</span></code> returns <code class="docutils literal"><span class="pre">true</span></code> if the current <code class="docutils literal"><span class="pre">MediaItem</span></code> is a <code class="docutils literal"><span class="pre">Movie</span></code> instance and <code class="docutils literal"><span class="pre">false</span></code> if it is not. Similarly, <code class="docutils literal"><span class="pre">item</span> <span class="pre">is</span> <span class="pre">Song</span></code> checks whether the item is a <code class="docutils literal"><span class="pre">Song</span></code> instance. At the end of the <code class="docutils literal"><span class="pre">for</span></code>-<code class="docutils literal"><span class="pre">in</span></code> loop, the values of <code class="docutils literal"><span class="pre">movieCount</span></code> and <code class="docutils literal"><span class="pre">songCount</span></code> contain a count of how many <code class="docutils literal"><span class="pre">MediaItem</span></code> instances were found of each type.</p>
</div>
<div class="section" id="ID341">
<a class="dashingAutolink" name="autolink-200"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Downcasting"></a><h2>Downcasting<a class="headerlink" href="TypeCasting.html#ID341" title="Permalink to this headline"></a></h2>
<p>A constant or variable of a certain class type may actually refer to an instance of a subclass behind the scenes. Where you believe this is the case, you can try to <em>downcast</em> to the subclass type with a <em>type cast operator</em> (<code class="docutils literal"><span class="pre">as?</span></code> or <code class="docutils literal"><span class="pre">as!</span></code>).</p>
<p>Because downcasting can fail, the type cast operator comes in two different forms. The conditional form, <code class="docutils literal"><span class="pre">as?</span></code>, returns an optional value of the type you are trying to downcast to. The forced form, <code class="docutils literal"><span class="pre">as!</span></code>, attempts the downcast and force-unwraps the result as a single compound action.</p>
<p>Use the conditional form of the type cast operator (<code class="docutils literal"><span class="pre">as?</span></code>) when you are not sure if the downcast will succeed. This form of the operator will always return an optional value, and the value will be <code class="docutils literal"><span class="pre">nil</span></code> if the downcast was not possible. This enables you to check for a successful downcast.</p>
<p>Use the forced form of the type cast operator (<code class="docutils literal"><span class="pre">as!</span></code>) only when you are sure that the downcast will always succeed. This form of the operator will trigger a runtime error if you try to downcast to an incorrect class type.</p>
<p>The example below iterates over each <code class="docutils literal"><span class="pre">MediaItem</span></code> in <code class="docutils literal"><span class="pre">library</span></code>, and prints an appropriate description for each item. To do this, it needs to access each item as a true <code class="docutils literal"><span class="pre">Movie</span></code> or <code class="docutils literal"><span class="pre">Song</span></code>, and not just as a <code class="docutils literal"><span class="pre">MediaItem</span></code>. This is necessary in order for it to be able to access the <code class="docutils literal"><span class="pre">director</span></code> or <code class="docutils literal"><span class="pre">artist</span></code> property of a <code class="docutils literal"><span class="pre">Movie</span></code> or <code class="docutils literal"><span class="pre">Song</span></code> for use in the description.</p>
<p>In this example, each item in the array might be a <code class="docutils literal"><span class="pre">Movie</span></code>, or it might be a <code class="docutils literal"><span class="pre">Song</span></code>. You don&rsquo;t know in advance which actual class to use for each item, and so it is appropriate to use the conditional form of the type cast operator (<code class="docutils literal"><span class="pre">as?</span></code>) to check the downcast each time through the loop:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">for</span> <span class="nv">item</span> <span class="k">in</span> <span class="nv">library</span> {
</li><li>    <span class="k">if</span> <span class="k">let</span> <span class="nv">movie</span> = <span class="nv">item</span> <span class="k">as</span>? <span class="nc">Movie</span> {
</li><li>        <span class="nv">print</span>(<span class="s">&#34;Movie: </span>\<span class="p">(</span><span class="nv">movie</span>.<span class="nv">name</span><span class="p">)</span><span class="s">, dir. </span>\<span class="p">(</span><span class="nv">movie</span>.<span class="nv">director</span><span class="p">)</span><span class="s">&#34;</span>)
</li><li>    } <span class="k">else</span> <span class="k">if</span> <span class="k">let</span> <span class="nv">song</span> = <span class="nv">item</span> <span class="k">as</span>? <span class="nc">Song</span> {
</li><li>        <span class="nv">print</span>(<span class="s">&#34;Song: </span>\<span class="p">(</span><span class="nv">song</span>.<span class="nv">name</span><span class="p">)</span><span class="s">, by </span>\<span class="p">(</span><span class="nv">song</span>.<span class="nv">artist</span><span class="p">)</span><span class="s">&#34;</span>)
</li><li>    }
</li><li>}
</li><li>
</li><li><span class="c">// Movie: Casablanca, dir. Michael Curtiz</span>
</li><li><span class="c">// Song: Blue Suede Shoes, by Elvis Presley</span>
</li><li><span class="c">// Movie: Citizen Kane, dir. Orson Welles</span>
</li><li><span class="c">// Song: The One And Only, by Chesney Hawkes</span>
</li><li><span class="c">// Song: Never Gonna Give You Up, by Rick Astley</span>
</li></ol></pre></div></div>
<p>The example starts by trying to downcast the current <code class="docutils literal"><span class="pre">item</span></code> as a <code class="docutils literal"><span class="pre">Movie</span></code>. Because <code class="docutils literal"><span class="pre">item</span></code> is a <code class="docutils literal"><span class="pre">MediaItem</span></code> instance, it&rsquo;s possible that it <em>might</em> be a <code class="docutils literal"><span class="pre">Movie</span></code>; equally, it&rsquo;s also possible that it might be a <code class="docutils literal"><span class="pre">Song</span></code>, or even just a base <code class="docutils literal"><span class="pre">MediaItem</span></code>. Because of this uncertainty, the <code class="docutils literal"><span class="pre">as?</span></code> form of the type cast operator returns an <em>optional</em> value when attempting to downcast to a subclass type. The result of <code class="docutils literal"><span class="pre">item</span> <span class="pre">as?</span> <span class="pre">Movie</span></code> is of type <code class="docutils literal"><span class="pre">Movie?</span></code>, or &ldquo;optional <code class="docutils literal"><span class="pre">Movie</span></code>&rdquo;.</p>
<p>Downcasting to <code class="docutils literal"><span class="pre">Movie</span></code> fails when applied to the <code class="docutils literal"><span class="pre">Song</span></code> instances in the library array. To cope with this, the example above uses optional binding to check whether the optional <code class="docutils literal"><span class="pre">Movie</span></code> actually contains a value (that is, to find out whether the downcast succeeded.) This optional binding is written &ldquo;<code class="docutils literal"><span class="pre">if</span> <span class="pre">let</span> <span class="pre">movie</span> <span class="pre">=</span> <span class="pre">item</span> <span class="pre">as?</span> <span class="pre">Movie</span></code>&rdquo;, which can be read as:</p>
<p>&ldquo;Try to access <code class="docutils literal"><span class="pre">item</span></code> as a <code class="docutils literal"><span class="pre">Movie</span></code>. If this is successful, set a new temporary constant called <code class="docutils literal"><span class="pre">movie</span></code> to the value stored in the returned optional <code class="docutils literal"><span class="pre">Movie</span></code>.&rdquo;</p>
<p>If the downcasting succeeds, the properties of <code class="docutils literal"><span class="pre">movie</span></code> are then used to print a description for that <code class="docutils literal"><span class="pre">Movie</span></code> instance, including the name of its <code class="docutils literal"><span class="pre">director</span></code>. A similar principle is used to check for <code class="docutils literal"><span class="pre">Song</span></code> instances, and to print an appropriate description (including <code class="docutils literal"><span class="pre">artist</span></code> name) whenever a <code class="docutils literal"><span class="pre">Song</span></code> is found in the library.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Casting does not actually modify the instance or change its values. The underlying instance remains the same; it is simply treated and accessed as an instance of the type to which it has been cast.</p>
</div>
</div>
<div class="section" id="ID342">
<a class="dashingAutolink" name="autolink-201"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Type%20Casting%20for%20Any%20and%20AnyObject"></a><h2>Type Casting for Any and AnyObject<a class="headerlink" href="TypeCasting.html#ID342" title="Permalink to this headline"></a></h2>
<p>Swift provides two special types for working with nonspecific types:</p>
<ul class="simple">
<li><code class="docutils literal"><span class="pre">Any</span></code> can represent an instance of any type at all, including function types.</li>
<li><code class="docutils literal"><span class="pre">AnyObject</span></code> can represent an instance of any class type.</li>
</ul>
<p>Use <code class="docutils literal"><span class="pre">Any</span></code> and <code class="docutils literal"><span class="pre">AnyObject</span></code> only when you explicitly need the behavior and capabilities they provide. It is always better to be specific about the types you expect to work with in your code.</p>
<p>Here&rsquo;s an example of using <code class="docutils literal"><span class="pre">Any</span></code> to work with a mix of different types, including function types and nonclass types. The example creates an array called <code class="docutils literal"><span class="pre">things</span></code>, which can store values of type <code class="docutils literal"><span class="pre">Any</span></code>:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">var</span> <span class="nv">things</span> = [<span class="k">Any</span>]()
</li><li>
</li><li><span class="nv">things</span>.<span class="nv">append</span>(<span class="m">0</span>)
</li><li><span class="nv">things</span>.<span class="nv">append</span>(<span class="m">0.0</span>)
</li><li><span class="nv">things</span>.<span class="nv">append</span>(<span class="m">42</span>)
</li><li><span class="nv">things</span>.<span class="nv">append</span>(<span class="m">3.14159</span>)
</li><li><span class="nv">things</span>.<span class="nv">append</span>(<span class="s">&#34;hello&#34;</span>)
</li><li><span class="nv">things</span>.<span class="nv">append</span>((<span class="m">3.0</span>, <span class="m">5.0</span>))
</li><li><span class="nv">things</span>.<span class="nv">append</span>(<span class="nv">Movie</span>(<span class="nv">name</span>: <span class="s">&#34;Ghostbusters&#34;</span>, <span class="nv">director</span>: <span class="s">&#34;Ivan Reitman&#34;</span>))
</li><li><span class="nv">things</span>.<span class="nv">append</span>({ (<span class="nv">name</span>: <span class="nc">String</span>) -&gt; <span class="nc">String</span> <span class="k">in</span> <span class="s">&#34;Hello, </span>\<span class="p">(</span><span class="nv">name</span><span class="p">)</span><span class="s">&#34;</span> })
</li></ol></pre></div></div>
<p>The <code class="docutils literal"><span class="pre">things</span></code> array contains two <code class="docutils literal"><span class="pre">Int</span></code> values, two <code class="docutils literal"><span class="pre">Double</span></code> values, a <code class="docutils literal"><span class="pre">String</span></code> value, a tuple of type <code class="docutils literal"><span class="pre">(Double,</span> <span class="pre">Double)</span></code>, the movie &ldquo;Ghostbusters&rdquo;, and a closure expression that takes a <code class="docutils literal"><span class="pre">String</span></code> value and returns another <code class="docutils literal"><span class="pre">String</span></code> value.</p>
<p>To discover the specific type of a constant or variable that is known only to be of type <code class="docutils literal"><span class="pre">Any</span></code> or <code class="docutils literal"><span class="pre">AnyObject</span></code>, you can use an <code class="docutils literal"><span class="pre">is</span></code> or <code class="docutils literal"><span class="pre">as</span></code> pattern in a <code class="docutils literal"><span class="pre">switch</span></code> statement&rsquo;s cases. The example below iterates over the items in the <code class="docutils literal"><span class="pre">things</span></code> array and queries the type of each item with a <code class="docutils literal"><span class="pre">switch</span></code> statement. Several of the <code class="docutils literal"><span class="pre">switch</span></code> statement&rsquo;s cases bind their matched value to a constant of the specified type to enable its value to be printed:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">for</span> <span class="nv">thing</span> <span class="k">in</span> <span class="nv">things</span> {
</li><li>    <span class="k">switch</span> <span class="nv">thing</span> {
</li><li>    <span class="k">case</span> <span class="m">0</span> <span class="k">as</span> <span class="nc">Int</span>:
</li><li>        <span class="nv">print</span>(<span class="s">&#34;zero as an Int&#34;</span>)
</li><li>    <span class="k">case</span> <span class="m">0</span> <span class="k">as</span> <span class="nc">Double</span>:
</li><li>        <span class="nv">print</span>(<span class="s">&#34;zero as a Double&#34;</span>)
</li><li>    <span class="k">case</span> <span class="k">let</span> <span class="nv">someInt</span> <span class="k">as</span> <span class="nc">Int</span>:
</li><li>        <span class="nv">print</span>(<span class="s">&#34;an integer value of </span>\<span class="p">(</span><span class="nv">someInt</span><span class="p">)</span><span class="s">&#34;</span>)
</li><li>    <span class="k">case</span> <span class="k">let</span> <span class="nv">someDouble</span> <span class="k">as</span> <span class="nc">Double</span> <span class="k">where</span> <span class="nv">someDouble</span> &gt; <span class="m">0</span>:
</li><li>        <span class="nv">print</span>(<span class="s">&#34;a positive double value of </span>\<span class="p">(</span><span class="nv">someDouble</span><span class="p">)</span><span class="s">&#34;</span>)
</li><li>    <span class="k">case</span> <span class="k">is</span> <span class="nc">Double</span>:
</li><li>        <span class="nv">print</span>(<span class="s">&#34;some other double value that I don&#39;t want to print&#34;</span>)
</li><li>    <span class="k">case</span> <span class="k">let</span> <span class="nv">someString</span> <span class="k">as</span> <span class="nc">String</span>:
</li><li>        <span class="nv">print</span>(<span class="s">&#34;a string value of \&#34;</span>\<span class="p">(</span><span class="nv">someString</span><span class="p">)</span><span class="s">\&#34;&#34;</span>)
</li><li>    <span class="k">case</span> <span class="k">let</span> (<span class="nv">x</span>, <span class="nv">y</span>) <span class="k">as</span> (<span class="nc">Double</span>, <span class="nc">Double</span>):
</li><li>        <span class="nv">print</span>(<span class="s">&#34;an (x, y) point at </span>\<span class="p">(</span><span class="nv">x</span><span class="p">)</span><span class="s">, </span>\<span class="p">(</span><span class="nv">y</span><span class="p">)</span><span class="s">&#34;</span>)
</li><li>    <span class="k">case</span> <span class="k">let</span> <span class="nv">movie</span> <span class="k">as</span> <span class="nc">Movie</span>:
</li><li>        <span class="nv">print</span>(<span class="s">&#34;a movie called </span>\<span class="p">(</span><span class="nv">movie</span>.<span class="nv">name</span><span class="p">)</span><span class="s">, dir. </span>\<span class="p">(</span><span class="nv">movie</span>.<span class="nv">director</span><span class="p">)</span><span class="s">&#34;</span>)
</li><li>    <span class="k">case</span> <span class="k">let</span> <span class="nv">stringConverter</span> <span class="k">as</span> (<span class="nc">String</span>) -&gt; <span class="nc">String</span>:
</li><li>        <span class="nv">print</span>(<span class="nv">stringConverter</span>(<span class="s">&#34;Michael&#34;</span>))
</li><li>    <span class="k">default</span>:
</li><li>        <span class="nv">print</span>(<span class="s">&#34;something else&#34;</span>)
</li><li>    }
</li><li>}
</li><li>
</li><li><span class="c">// zero as an Int</span>
</li><li><span class="c">// zero as a Double</span>
</li><li><span class="c">// an integer value of 42</span>
</li><li><span class="c">// a positive double value of 3.14159</span>
</li><li><span class="c">// a string value of &#34;hello&#34;</span>
</li><li><span class="c">// an (x, y) point at 3.0, 5.0</span>
</li><li><span class="c">// a movie called Ghostbusters, dir. Ivan Reitman</span>
</li><li><span class="c">// Hello, Michael</span>
</li></ol></pre></div></div>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p>The <code class="docutils literal"><span class="pre">Any</span></code> type represents values of any type, including optional types. Swift gives you a warning if you use an optional value where a value of type <code class="docutils literal"><span class="pre">Any</span></code> is expected. If you really do need to use an optional value as an <code class="docutils literal"><span class="pre">Any</span></code> value, you can use the <code class="docutils literal"><span class="pre">as</span></code> operator to explicitly cast the optional to <code class="docutils literal"><span class="pre">Any</span></code>, as shown below.</p>
<div class="last highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">optionalNumber</span>: <span class="nc">Int</span>? = <span class="m">3</span>
</li><li><span class="nv">things</span>.<span class="nv">append</span>(<span class="nv">optionalNumber</span>)        <span class="c">// Warning</span>
</li><li><span class="nv">things</span>.<span class="nv">append</span>(<span class="nv">optionalNumber</span> <span class="k">as</span> <span class="k">Any</span>) <span class="c">// No warning</span>
</li></ol></pre></div></div>
</div>
</div>
</div>


    </article>
    <div class="next_previous">
        <p class="previous"><a href="ErrorHandling.html">Error Handling</a></p>
        <p class="next"><a href="NestedTypes.html">Nested Types</a></p>
    </div>

    <div class="admonition-beta admonition">
        <p class="first admonition-title">Beta Software</p>
        <p>
          This documentation contains preliminary information about an API or technology in development.
          This information is subject to change, and software implemented according to this documentation should be tested with final operating system software.
        </p>
        <p class="last"><a class="reference external" href="https://developer.apple.com/support/beta-software/">Learn more about using Apple&#39;s beta software</a></p>
    </div>
</main>


<footer role="contentinfo">
  <aside>
    <a href="https://swift.org/atom.xml" title="Subscribe to Site Updates"><i class="feed">Subscribe</i></a>
    <a href="https://twitter.com/swiftlang" rel="nofollow" title="Follow @SwiftLang on Twitter"><i class="twitter">Twitter</i></a>
  </aside>

  <p class="copyright">Copyright &copy; 2018 Apple Inc. All rights reserved.</p>
  <p class="trademark">Swift and the Swift logo are trademarks of Apple Inc.</p>
  <p class="privacy">
    <a href="https://www.apple.com/privacy/privacy-policy/">Privacy Policy</a>
    <a href="https://www.apple.com/legal/privacy/en-ww/cookies/">Cookies</a>
  </p>
</footer>
<div id="jump_to_overlay"></div>
<script src="../_static/javascripts/application.js"></script>
  

</body></html>